/**
* Wszystkie prawa zastrzeone.
* Autor: Tomasz Kaczanowski
* Licencja: Kod mona modyfikowa, oraz uy we wasnych rozwizaniach nieodpatnie,
* jedyny wymg - konieczno podania w dokumentacji informacji o wykorzystaniu kodu
* oraz autora - Tomasza Kaczanowskiego. Jeli jest jaka informacja o programie
* - rwnie tam naley umieci adekwatn informacj.
*/

#include "mydefaultobj.h"
#include <stdio.h>

int cDBGTXT_FLG = 0;

void myprintdbg(const char *astr)
{
    if (cDBGTXT_FLG)
    	puts(astr);
}

void ShowObjectInfo(FILE *afout, struct TDefaultObj *aobj)
{
    if (aobj)
    {
    	if (aobj->fooShowObjInfo)
        {
            aobj->fooShowObjInfo(afout, aobj);
    	}
        else
            myprintdbg("ShowObjectInfo: brak zdefiniowanej metody fooShowObjInfo!");


    }
    else
        myprintdbg("ShowObjectInfo: brak obiektu!!!!!");
}



struct TDefaultObj *CloneDefaultObject(struct TDefaultObj *asrc)
{
	struct TDefaultObj *lres = NULL;
	size_t x;
	if (asrc)
	{
		if (asrc->fooCloneObj != NULL)
        {
			myprintdbg("CloneDefaultObject: wywoanie metody nadrzdnej CloneObj");
            lres = asrc->fooCloneObj(asrc);
        }
		else if(asrc->fooGetSize != NULL)
		{
			myprintdbg("CloneDefaultObject: utworzenie nowego obiektu");
            x = asrc->fooGetSize(asrc);
			lres = (struct TDefaultObj *)malloc(x);
			memcpy(lres, asrc, x);
		}
	}

	return lres;
}

void FreeDefaultObject(struct TDefaultObj *asrc)
{
	if (asrc)
	{
		if (asrc->fooDestructor == NULL)
		{
			myprintdbg("FreeDefaultObject: wywoano domylny destruktor");
            free(asrc);
		}
		else
        {
			myprintdbg("FreeDefaultObject: wywoano destruktor nadrzdny");
            asrc->fooDestructor(asrc);
       	}
	}
}
