#include "kacparser.h"
#include <stdio.h>




int main(int argc, char *argv[])
{
    int i;
    char *buf = NULL;
    int len = 0;
    char *pbuf;
    struct TKacParser *parser = NULL;
    if (argc > 1)
    {
        for (i = 1; i < argc; i++)
        {
        	len += strlen(argv[i]);
    	}
        buf = (char *)malloc(len + 1);
        pbuf = buf;
        for (i = 1; i < argc; i++)
        {
            strcpy(pbuf, argv[i]);
            pbuf += strlen(argv[i]);
        }
        buf[len] = 0;
        parser = doPreParse(buf);

        if (parser)
        {
            printf("Wprowadzono: %s\n", buf);
            printf("Mamy dziaanie: ");
            doPrintInfo(stdout, parser);
            printf(" = %f\n", doParserEvalue(parser));
            FreeParserObject(parser);

        }



        if (buf)
        	free(buf);
    }
	else
    	printf("\aBd - brak argumentu\n");
    return 0;
}

