/**
* Wszystkie prawa zastrzeone.
* Autor: Tomasz Kaczanowski
* Licencja: Kod mona modyfikowa, oraz uy we wasnych rozwizaniach nieodpatnie,
* jedyny wymg - konieczno podania w dokumentacji informacji o wykorzystaniu kodu
* oraz autora - Tomasza Kaczanowskiego. Jeli jest jaka informacja o programie
* - rwnie tam naley umieci adekwatn informacj.
*/

#ifndef _MYDEFAULTOBJ_H
#define _MYDEFAULTOBJ_H

#include <string.h>
#include <stdio.h>

extern int cDBGTXT_FLG;/**< 0 nie ma napisw, 1 s napisy*/

struct TDefaultObj;

typedef void (*ObjectDefaultDestructor)(struct TDefaultObj *);
typedef size_t (*ObjectDefaultGetSize)(struct TDefaultObj *);
typedef struct TDefaultObj * (*ObjectDefaultClone)(struct TDefaultObj *);
typedef void (*ObjectDefaultShowInfo)(FILE *afout, struct TDefaultObj *);

struct TDefaultObj
{
	ObjectDefaultDestructor fooDestructor;
	ObjectDefaultGetSize fooGetSize;
	ObjectDefaultClone fooCloneObj;
    ObjectDefaultShowInfo fooShowObjInfo;
};

struct TDefaultObj *CloneDefaultObject(struct TDefaultObj *asrc);
void FreeDefaultObject(struct TDefaultObj *aobj);
void ShowObjectInfo(FILE *afout, struct TDefaultObj *);

#endif
